# Class WsFilter

java.lang.Object
javax.servlet.GenericFilter
org.apache.tomcat.websocket.server.WsFilter

All Implemented Interfaces:
  `Serializable`, `Filter`, `FilterConfig`

public class WsFilter extends GenericFilter
Handles the initial HTTP connection for WebSocket connections.

See Also:
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`WsFilter()`

## Method Summary

Modifier and Type
Method
Description
`void`
`doFilter(ServletRequest request, ServletResponse response, FilterChain chain)`
The `doFilter` method of the Filter is called by the container each time a request/response pair is passed through the chain due to a client request for a resource at the end of the chain.
`void`
`init()`
Convenience method for sub-classes to save them having to call `super.init(config)`.

### Methods inherited from class javax.servlet.GenericFilter

`getFilterConfig, getFilterName, getInitParameter, getInitParameterNames, getServletContext, init`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface javax.servlet.Filter

`destroy`

## Constructor Details

### WsFilter

public WsFilter()

## Method Details

### init

public void init() throws ServletException
Description copied from class: `javax.servlet.GenericFilter`
Convenience method for sub-classes to save them having to call `super.init(config)`. This is a NO-OP by default.

Overrides:
  `init` in class `GenericFilter`
Throws:
  `ServletException` - If an exception occurs that interrupts the Filter's normal operation

### doFilter

public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException
Description copied from interface: `javax.servlet.Filter`
The `doFilter` method of the Filter is called by the container each time a request/response pair is passed through the chain due to a client request for a resource at the end of the chain. The FilterChain passed in to this method allows the Filter to pass on the request and response to the next entity in the chain.

A typical implementation of this method would follow the following pattern:-
1. Examine the request
2. Optionally wrap the request object with a custom implementation to filter content or headers for input filtering
3. Optionally wrap the response object with a custom implementation to filter content or headers for output filtering
4. a) Either invoke the next entity in the chain using the FilterChain object (`chain.doFilter()`),
4. b) or not pass on the request/response pair to the next entity in the filter chain to block the request processing
5. Directly set headers on the response after invocation of the next entity in the filter chain.

Parameters:
  `request` - The request to process
  `response` - The response associated with the request
  `chain` - Provides access to the next filter in the chain for this filter to pass the request and response to for further processing
Throws:
  `IOException` - if an I/O error occurs during this filter's processing of the request
  `ServletException` - if the processing fails for any other reason